#!/bin/bash
#######################################################################################
# Copyright ETSI Contributors and Others.
#
# Licensed under the Apache License, Version 2.0 (the "License");
# you may not use this file except in compliance with the License.
# You may obtain a copy of the License at
#
#    http://www.apache.org/licenses/LICENSE-2.0
#
# Unless required by applicable law or agreed to in writing, software
# distributed under the License is distributed on an "AS IS" BASIS,
# WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or
# implied.
# See the License for the specific language governing permissions and
# limitations under the License.
#######################################################################################
#
# Script to upload documentation to ETSI site
#

source ./env-ftp

# Get credentias (file or interactive)
if [ -f local/.credentials ]; then
	source local/.credentials
	echo SERVER=${SERVER}
	echo USERNAME=${USERNAME}
else
	echo "Enter credentials for ${SERVER} (ETSI On Line account)"
	read -p  "Username: " USERNAME
	read -sp "Password: " PASSWORD
fi

lftp ${FTP_OPTS} -u ${USERNAME},${PASSWORD} ${SERVER} << !
   set ftp:ssl-allow no
   cd ${FOLDER}
   lcd ../installers
   put install_osm.sh
   bye
!
